// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.


import HTTP

public extension Bot {

    /// Use this method to generate a new invite link for a chat; any previously generated link is revoked. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. Returns the new invite link as String on success.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    /// - Returns: Future<String>. Throws on errors.
    /// - Note: Asynchronous method.
    ///
    /// [- SeeAlso: ]<https://core.telegram.org/bots/api#exportchatinvitelink>

    public struct ExportChatInviteLinkParams: JSONEncodable {
        var chatId: ChatId

        enum CodingKeys: String, CodingKey {
            case chatId = "chat_id"
        }

        public init(chatId: ChatId) {
            self.chatId = chatId
        }
    }

    @discardableResult
    public func exportChatInviteLink(params: ExportChatInviteLinkParams) throws -> Future<String> {
        let body = try httpBody(for: params)
        let headers = httpHeaders(for: params)
        let response: Future<TelegramContainer<String>>
        response = try client.respond(endpoint: "exportChatInviteLink", body: body, headers: headers)
        return response.flatMap(to: String.self) { try self.wrap($0) }
    }
}
