// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.


import HTTP

public extension Bot {

    /// Use this method to get data for high score tables. Will return the score of the specified user and several of his neighbors in a game. On success, returns an Array of GameHighScore objects.
    /// This method will currently return scores for the target user, plus two of his closest neighbors on each side. Will also return the top three users if the user and his neighbors are not among them. Please note that this behavior is subject to change.
    /// - Parameters:
    ///     - user_id: Target user id
    ///     - chat_id: Required if inline_message_id is not specified. Unique identifier for the target chat
    ///     - message_id: Required if inline_message_id is not specified. Identifier of the sent message
    ///     - inline_message_id: Required if chat_id and message_id are not specified. Identifier of the inline message
    /// - Returns: Future<[GameHighScore]>. Throws on errors.
    /// - Note: Asynchronous method.
    ///
    /// [- SeeAlso: ]<https://core.telegram.org/bots/api#getgamehighscores>

    public struct GetGameHighScoresParams: JSONEncodable {
        var userId: Int64
        var chatId: Int64?
        var messageId: Int?
        var inlineMessageId: String?

        enum CodingKeys: String, CodingKey {
            case userId = "user_id"
            case chatId = "chat_id"
            case messageId = "message_id"
            case inlineMessageId = "inline_message_id"
        }

        public init(userId: Int64, chatId: Int64? = nil, messageId: Int? = nil, inlineMessageId: String? = nil) {
            self.userId = userId
            self.chatId = chatId
            self.messageId = messageId
            self.inlineMessageId = inlineMessageId
        }
    }

    @discardableResult
    public func getGameHighScores(params: GetGameHighScoresParams) throws -> Future<[GameHighScore]> {
        let body = try httpBody(for: params)
        let headers = httpHeaders(for: params)
        let response: Future<TelegramContainer<[GameHighScore]>>
        response = try client.respond(endpoint: "getGameHighScores", body: body, headers: headers)
        return response.flatMap(to: [GameHighScore].self) { try self.wrap($0) }
    }
}
