// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.

/// Represents a link to a page containing an embedded video player or a video file. By default, this video file will be sent by the user with an optional caption. Alternatively, you can use input_message_content to send a message with the specified content instead of the video.
/// If an InlineQueryResultVideo message contains an embedded video (e.g., YouTube), you must replace its content using input_message_content.
///
/// [- SeeAlso: ]<https://core.telegram.org/bots/api#inlinequeryresultvideo>

public final class InlineQueryResultVideo: Codable {
    
    enum CodingKeys: String, CodingKey {
        case type = "type"
        case id = "id"
        case videoUrl = "video_url"
        case mimeType = "mime_type"
        case thumbUrl = "thumb_url"
        case title = "title"
        case caption = "caption"
        case parseMode = "parse_mode"
        case videoWidth = "video_width"
        case videoHeight = "video_height"
        case videoDuration = "video_duration"
        case description = "description"
        case replyMarkup = "reply_markup"
        case inputMessageContent = "input_message_content"
    }

    public var type: String
    public var id: String
    public var videoUrl: String
    public var mimeType: String
    public var thumbUrl: String
    public var title: String
    public var caption: String?
    public var parseMode: String?
    public var videoWidth: Int?
    public var videoHeight: Int?
    public var videoDuration: Int?
    public var description: String?
    public var replyMarkup: InlineKeyboardMarkup?
    public var inputMessageContent: InputMessageContent?

    public init (type: String, id: String, videoUrl: String, mimeType: String, thumbUrl: String, title: String, caption: String? = nil, parseMode: String? = nil, videoWidth: Int? = nil, videoHeight: Int? = nil, videoDuration: Int? = nil, description: String? = nil, replyMarkup: InlineKeyboardMarkup? = nil, inputMessageContent: InputMessageContent? = nil) {
        self.type = type
        self.id = id
        self.videoUrl = videoUrl
        self.mimeType = mimeType
        self.thumbUrl = thumbUrl
        self.title = title
        self.caption = caption
        self.parseMode = parseMode
        self.videoWidth = videoWidth
        self.videoHeight = videoHeight
        self.videoDuration = videoDuration
        self.description = description
        self.replyMarkup = replyMarkup
        self.inputMessageContent = inputMessageContent
    }

}

