// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.

/// This object represents a message.
///
/// [- SeeAlso: ]<https://core.telegram.org/bots/api#message>

public final class Message: Codable {
    
    enum CodingKeys: String, CodingKey {
        case messageId = "message_id"
        case from = "from"
        case date = "date"
        case chat = "chat"
        case forwardFrom = "forward_from"
        case forwardFromChat = "forward_from_chat"
        case forwardFromMessageId = "forward_from_message_id"
        case forwardSignature = "forward_signature"
        case forwardDate = "forward_date"
        case replyToMessage = "reply_to_message"
        case editDate = "edit_date"
        case mediaGroupId = "media_group_id"
        case authorSignature = "author_signature"
        case text = "text"
        case entities = "entities"
        case captionEntities = "caption_entities"
        case audio = "audio"
        case document = "document"
        case game = "game"
        case photo = "photo"
        case sticker = "sticker"
        case video = "video"
        case voice = "voice"
        case videoNote = "video_note"
        case caption = "caption"
        case contact = "contact"
        case location = "location"
        case venue = "venue"
        case newChatMembers = "new_chat_members"
        case leftChatMember = "left_chat_member"
        case newChatTitle = "new_chat_title"
        case newChatPhoto = "new_chat_photo"
        case deleteChatPhoto = "delete_chat_photo"
        case groupChatCreated = "group_chat_created"
        case supergroupChatCreated = "supergroup_chat_created"
        case channelChatCreated = "channel_chat_created"
        case migrateToChatId = "migrate_to_chat_id"
        case migrateFromChatId = "migrate_from_chat_id"
        case pinnedMessage = "pinned_message"
        case invoice = "invoice"
        case successfulPayment = "successful_payment"
        case connectedWebsite = "connected_website"
    }

    public var messageId: Int
    public var from: User?
    public var date: Int
    public var chat: Chat
    public var forwardFrom: User?
    public var forwardFromChat: Chat?
    public var forwardFromMessageId: Int?
    public var forwardSignature: String?
    public var forwardDate: Int?
    public var replyToMessage: Message?
    public var editDate: Int?
    public var mediaGroupId: String?
    public var authorSignature: String?
    public var text: String?
    public var entities: [MessageEntity]?
    public var captionEntities: [MessageEntity]?
    public var audio: Audio?
    public var document: Document?
    public var game: Game?
    public var photo: [PhotoSize]?
    public var sticker: Sticker?
    public var video: Video?
    public var voice: Voice?
    public var videoNote: VideoNote?
    public var caption: String?
    public var contact: Contact?
    public var location: Location?
    public var venue: Venue?
    public var newChatMembers: [User]?
    public var leftChatMember: User?
    public var newChatTitle: String?
    public var newChatPhoto: [PhotoSize]?
    public var deleteChatPhoto: Bool?
    public var groupChatCreated: Bool?
    public var supergroupChatCreated: Bool?
    public var channelChatCreated: Bool?
    public var migrateToChatId: Int64?
    public var migrateFromChatId: Int64?
    public var pinnedMessage: Message?
    public var invoice: Invoice?
    public var successfulPayment: SuccessfulPayment?
    public var connectedWebsite: String?

    public init (messageId: Int, from: User? = nil, date: Int, chat: Chat, forwardFrom: User? = nil, forwardFromChat: Chat? = nil, forwardFromMessageId: Int? = nil, forwardSignature: String? = nil, forwardDate: Int? = nil, replyToMessage: Message? = nil, editDate: Int? = nil, mediaGroupId: String? = nil, authorSignature: String? = nil, text: String? = nil, entities: [MessageEntity]? = nil, captionEntities: [MessageEntity]? = nil, audio: Audio? = nil, document: Document? = nil, game: Game? = nil, photo: [PhotoSize]? = nil, sticker: Sticker? = nil, video: Video? = nil, voice: Voice? = nil, videoNote: VideoNote? = nil, caption: String? = nil, contact: Contact? = nil, location: Location? = nil, venue: Venue? = nil, newChatMembers: [User]? = nil, leftChatMember: User? = nil, newChatTitle: String? = nil, newChatPhoto: [PhotoSize]? = nil, deleteChatPhoto: Bool? = nil, groupChatCreated: Bool? = nil, supergroupChatCreated: Bool? = nil, channelChatCreated: Bool? = nil, migrateToChatId: Int64? = nil, migrateFromChatId: Int64? = nil, pinnedMessage: Message? = nil, invoice: Invoice? = nil, successfulPayment: SuccessfulPayment? = nil, connectedWebsite: String? = nil) {
        self.messageId = messageId
        self.from = from
        self.date = date
        self.chat = chat
        self.forwardFrom = forwardFrom
        self.forwardFromChat = forwardFromChat
        self.forwardFromMessageId = forwardFromMessageId
        self.forwardSignature = forwardSignature
        self.forwardDate = forwardDate
        self.replyToMessage = replyToMessage
        self.editDate = editDate
        self.mediaGroupId = mediaGroupId
        self.authorSignature = authorSignature
        self.text = text
        self.entities = entities
        self.captionEntities = captionEntities
        self.audio = audio
        self.document = document
        self.game = game
        self.photo = photo
        self.sticker = sticker
        self.video = video
        self.voice = voice
        self.videoNote = videoNote
        self.caption = caption
        self.contact = contact
        self.location = location
        self.venue = venue
        self.newChatMembers = newChatMembers
        self.leftChatMember = leftChatMember
        self.newChatTitle = newChatTitle
        self.newChatPhoto = newChatPhoto
        self.deleteChatPhoto = deleteChatPhoto
        self.groupChatCreated = groupChatCreated
        self.supergroupChatCreated = supergroupChatCreated
        self.channelChatCreated = channelChatCreated
        self.migrateToChatId = migrateToChatId
        self.migrateFromChatId = migrateFromChatId
        self.pinnedMessage = pinnedMessage
        self.invoice = invoice
        self.successfulPayment = successfulPayment
        self.connectedWebsite = connectedWebsite
    }

}

